//Search supprot
var CTBR_SearchProviders,CTBR_SearchProvider='';
var CTBR_TbId;

//Look for button support
var CTBR_LookForData, CTBR_LookFor='';

// XPCOM components
var objWSG, objShared, objSupport;

function AddNewTab(URL)
{
  var browser = getBrowser(); 
  browser.selectedTab = browser.addTab(URL); 
}

function BaseWinFromDOMWin(aWindow)
{ 
  return aWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor) 
                .getInterface(Components.interfaces.nsIWebNavigation) 
                .QueryInterface(Components.interfaces.nsIDocShellTreeItem) 
                .treeOwner 
                .QueryInterface(Components.interfaces.nsIInterfaceRequestor) 
                .getInterface(Components.interfaces.nsIBaseWindow); 
} 

//*********************************************
//    XPCOM init
//*********************************************
function CTBR_XPCOMInit()
{
   try 
   {
      netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      
      const cid_shared = "@crawler.com/xshared;1";
      objShared = Components.classes[cid_shared].createInstance();
      objShared = objShared.QueryInterface(Components.interfaces.IxCrawlerShared);
      
	  try
	  {
      const cid_wsg = "@crawler.com/wsg;1";
      objWSG = Components.classes[cid_wsg].createInstance();
      objWSG = objWSG.QueryInterface(Components.interfaces.IxCrawlerPlugin);
	  }
		catch(e)
		{
		objWSG = null;
		//alert('wsg not loaded');
		}
	  
      const cid_support = "@crawler.com/support;1";
      objSupport = Components.classes[cid_support].createInstance();
      objSupport = objSupport.QueryInterface(Components.interfaces.IxCrawlerSupport);
   } 
   
   catch (err) 
   {
     alert(err);
     return;
   }
}


//*********************************************
//     Tab events
//*********************************************

function CTBR_TabSelected(event)
{
  //alert("Tab event");
  //var browser = gBrowser.selectedTab;
  if (objWSG!=null)
	objWSG.TabActivate(window.content);
}

function CTBR_InitTabEvents()
{   
   var container = getBrowser().tabContainer;
   container.addEventListener("TabSelect", CTBR_TabSelected, false);
}



/*************************************/
//     Common string utils and navigation support
/*************************************/
function CTBR_TrimString(string)
{
   if (!string)
      return "";

   string = string.replace(/^\s+/, ''); // Remove leading whitespace
   string = string.replace(/\s+$/, ''); // Remove trailing whitespace

   string = string.replace(/\s+/g, ' ');

   return string; 
}

function CTBR_ConvertTermsToURI(terms)
{
   var termArray = new Array();
   termArray = terms.split(" ");
   var result = "";
   for(var i=0; i<termArray.length; i++)
   {
      if(i > 0)
         result += "+";
      result += encodeURIComponent(termArray[i]);
   }
   return result;
}

function CTBR_GetSearchTerms(doConvert)
{
   var searchTermsBox = document.getElementById("CTBR_SRCHTERMS");
   var searchTerms = CTBR_TrimString(searchTermsBox.value);

   if ((searchTerms.length != 0)&&(doConvert)) 
      searchTerms = CTBR_ConvertTermsToURI(searchTerms);
        
   return searchTerms;
}

function CTBR_ParseUrl(url)
{
   var sTerms=CTBR_GetSearchTerms(true);   
   var bSaveHist=(sTerms.length!=0)&(url.search(/#search#/i)>=0)
      
   url=url.replace(/#TbId#/gi,CTBR_TbId);
   url=url.replace(/#search#/gi,sTerms);
	
   var lang=CTBR_Translate('LanguageCode');

	 url=url.replace(/#lng#/gi,lang);
	 var language=(lang=="en")?"":"lang="+lang;
	 url=url.replace(/#language#/gi,language);

   if (bSaveHist) CTBR_AddSearchHist(CTBR_GetSearchTerms(false));

   return url;
}

function CTBR_Navigate(url)
{
   url=CTBR_ParseUrl(url);
   window._content.document.location = url;
   window.content.focus();
}

function CTBR_NavigateNew(url)
{
    url=CTBR_ParseUrl(url);
    window.open(url,"_blank");
}



/*************************************/
//             General events
/*************************************/

function CTBR_WSGButtonClick(event,BtnID)
{
   var Btn = document.getElementById("CTBR_WSG_BUTTON");
   if (objWSG!=null)
	objWSG.ButtonClick("WSG", BtnID, Btn.boxObject.screenX, Btn.boxObject.screenY+Btn.boxObject.height-3);
   
   event.preventBubble();
}

function CTBR_WSGMenuClick(event,BtnID,MenuID)
{
   var Btn = document.getElementById("CTBR_WSG_BUTTON");
   if (objWSG!=null)
	objWSG.MenuClick("WSG", BtnID, MenuID, Btn.boxObject.screenX, Btn.boxObject.screenY+Btn.boxObject.height-3);
   
   event.preventBubble();
}

function CTBR_Alert(caption)
{
   alert(caption);
}



/*************************************/
//         Menu  support
/*************************************/

function CTBR_ParseMenu(txtData)
{
   var tmpData=txtData.split("\n");
   for(var i=0; i<tmpData.length; i++)
   {
      tmpData[i]=tmpData[i].split("|");
   }
   return tmpData;
}

function CTBR_LoadMenu(menuID,menuData,idxCaption,idxKey,idxClass,idxSrc,txtCommand,txtTooltip)
{
   var tmpMenu = document.getElementById(menuID);
	 
   if ((tmpMenu)&&(menuData)&&(idxCaption>=0))
   {
      for(var i=tmpMenu.childNodes.length - 1; i >= 0; i--)
      {
         tmpMenu.removeChild(tmpMenu.childNodes.item(i));
      }
      
      for(var i=0; i<menuData.length; i++)
      {
         var tmpItem=menuData[i];
         var tmpNewMenuItem;
      
         if (tmpItem[idxCaption]=="<") 
         {
            tmpMenu=tmpMenu.parentNode.parentNode;
               //alert("submenu OUT");
         }
         else
         if (tmpItem[idxCaption]=="-") 
         {
            tmpNewMenuItem=document.createElement("menuseparator");
            tmpMenu.appendChild(tmpNewMenuItem);
         }
         else
         if (tmpItem[idxCaption])
         {
            var sCaption=tmpItem[idxCaption],sKey="",isSubmenu=false;
						if(sCaption.charAt(0)=="+"){isSubmenu=true;sCaption=sCaption.substr(1);}
            sCaption=CTBR_Translate(sCaption);

            if (idxKey>=0) sKey=tmpItem[idxKey];
            
            if (isSubmenu)
            {
               
               tmpNewMenuItem=document.createElement("menu");
               tmpNewMenuItem.setAttribute("label", sCaption);
               tmpNewMenuItem.setAttribute("tooltiptext",sCaption);
               tmpMenu.appendChild(tmpNewMenuItem);
               var tmpPopup=document.createElement("menupopup");
               tmpNewMenuItem.appendChild(tmpPopup);
               tmpMenu=tmpPopup;
            }
            else
            {
               tmpNewMenuItem=document.createElement("menuitem");
               tmpNewMenuItem.setAttribute("label", sCaption);
							 tmpNewMenuItem.setAttribute("key", sKey);
               
               if (txtTooltip) 
               {
                  var s=txtTooltip;
                  s=s.replace(/#key#/gi,sKey);
                  s=s.replace(/#caption#/gi,sCaption);
                  tmpNewMenuItem.setAttribute("tooltiptext",s);
               } else
                  tmpNewMenuItem.setAttribute("tooltiptext",sCaption);
               
               if (idxKey>=0) tmpNewMenuItem.setAttribute("value",tmpItem[idxKey]);
               
               if (txtCommand)
               {
                  var s=txtCommand;
                  s=s.replace(/#key#/gi,sKey);
                  s=s.replace(/#caption#/gi,sCaption);
                  s=s.replace(/#TbId#/gi,CTBR_TbId);				  
        				  s=CTBR_TrimString(s);
                  tmpNewMenuItem.setAttribute("oncommand",s);
               }

							 tmpNewMenuItem.setAttribute("class","menuitem-iconic");
               if (idxClass>=0) tmpNewMenuItem.setAttribute("class","menuitem-iconic "+tmpItem[idxClass]);
							 if (idxSrc>=0) tmpNewMenuItem.setAttribute("src",tmpItem[idxSrc]);
               
    
               tmpMenu.appendChild(tmpNewMenuItem);
            }
         }
      }
   }
}








/*************************************/
//         Search history support
/*************************************/

function CTBR_ShowSearchHist(tmpMenu)
{
   if (!tmpMenu) return;
   
   for(var i=tmpMenu.childNodes.length - 1; i >= 0; i--)
   {
      tmpMenu.removeChild(tmpMenu.childNodes.item(i));
   }

   //Load search history dynamically
   var CTBR_SearchHistory=objShared.GetText("","GET_HIST","").split("\n");      
   var tmpNewMenuItem;
   for(var i=0; i<CTBR_SearchHistory.length; i++)
   {
      if (CTBR_SearchHistory[i])
      {
         tmpNewMenuItem=document.createElement("menuitem");
         tmpNewMenuItem.setAttribute("label", CTBR_SearchHistory[i]);
         tmpNewMenuItem.setAttribute("tooltiptext",CTBR_SearchHistory[i]);
         tmpNewMenuItem.setAttribute("value",CTBR_SearchHistory[i]);
         tmpNewMenuItem.setAttribute("oncommand","CTBR_SearchHistClick(this); event.preventBubble();");
         tmpMenu.appendChild(tmpNewMenuItem);
      }      
   }
   tmpNewMenuItem=document.createElement("menuseparator");
   tmpMenu.appendChild(tmpNewMenuItem);
   
   tmpNewMenuItem=document.createElement("menuitem");
   tmpNewMenuItem.setAttribute("label", "Clear Search History");
   tmpNewMenuItem.setAttribute("tooltiptext","Clear Search History");
   tmpNewMenuItem.setAttribute("oncommand","CTBR_ClearSearchHist(); event.preventBubble();");
   tmpMenu.appendChild(tmpNewMenuItem);
}

function CTBR_SearchHistClick(tmpItem)
{
   var tmpMenu = document.getElementById("CTBR_SRCHTERMS");
   tmpMenu.value=tmpItem.value;
	 CTBR_highlight.showHighlightButtons();
}

function CTBR_ClearSearchHist()
{
   var tmpMenu = document.getElementById("CTBR_SRCHTERMS");
   tmpMenu.value="";
   
   //Save configuration
   objShared.GetText("","CLEAR_HIST","");
	 CTBR_highlight.hideHighlightButtons();
}

function CTBR_AddSearchHist(addHist)
{
   if (addHist.length==0) addHist=CTBR_GetSearchTerms(false);
   
   if (addHist.length==0) return;
   
   //Save configuration
   objShared.GetText("","ADD_HIST",addHist);
}


/*************************************/
//         Search button support
/*************************************/

function CTBR_SearchLoad()
{
   //Load data
   var sSearchData=objShared.LoadCfgFile("","SEARCH");

   CTBR_SearchProviders=CTBR_ParseMenu(sSearchData);
   //Load menu
   CTBR_LoadMenu("CTBR_SEARCH_Menu",CTBR_SearchProviders,1,0,-1,-1,"CTBR_SetSearchProvider('#key#',true); event.preventBubble();");

	 /* Search settings menu item

	 var menu=document.getElementById('CTBR_SEARCH_Menu');
	 var tmpNewMenuItem;
	 tmpNewMenuItem=document.createElement("menuseparator");
	 menu.appendChild(tmpNewMenuItem);


	 tmpNewMenuItem=document.createElement("menuitem");
	 var sCaption=CTBR_Translate('Settings');
	 tmpNewMenuItem.setAttribute("label", sCaption);
	 tmpNewMenuItem.setAttribute("tooltiptext",sCaption);
	 tmpNewMenuItem.setAttribute("oncommand","CTBR_Settings(event,'Search')");
	 tmpNewMenuItem.setAttribute("class","menuitem-iconic");
	 menu.appendChild(tmpNewMenuItem);
		*/

  // CTBR_LoadMenu("CTBR_SRCHICON_Menu",CTBR_SearchProviders,1,0,-1,-1,"CTBR_SetSearchProvider('#key#',true); event.preventBubble();","#caption#");
   //Set menu item
   CTBR_SearchProvider=objShared.GetCfgStr("TBR","SRCH_PROVIDER",0);
   if (!CTBR_SearchProvider) CTBR_SearchProvider="DEF";
   CTBR_SetSearchProvider(CTBR_SearchProvider,false,false);
}

function CTBR_FindSearchProvider(providerID)
{  
   for(var i=0;i<CTBR_SearchProviders.length;i++)
   {
      if (CTBR_SearchProviders[i][0]==providerID) 
      {
         return CTBR_SearchProviders[i];
      }
   }
   return new Array("","","","","");
}

function CTBR_SetSearchProvider(providerID,doNavigate,doUpdate)
{
	 if(doUpdate===null)doUpdate=true;

   var tmpItem=CTBR_FindSearchProvider(providerID);

   var sCaption=tmpItem[2];
   if (!sCaption) sCaption=tmpItem[1];
	 sCaption=CTBR_Translate(sCaption);
   
   if ((tmpItem[0])&&(sCaption))
   {
      if (CTBR_SearchProvider!=providerID)
      {
         objShared.SetCfgStr("TBR","SRCH_PROVIDER",providerID,1);
         CTBR_SearchProvider=providerID;
      }
      
      var tmpButton=document.getElementById("CTBR_SEARCH");
      tmpButton.label=sCaption;
      tmpButton.setAttribute("tooltiptext",sCaption);
      
      var tmpImage=document.getElementById("CTBR_SRCHICON");
      if (tmpItem[4])
         tmpImage.setAttribute("src",tmpItem[4])
      else
         tmpImage.setAttribute("src","chrome://crawlertbr/skin/crawlertbr/search_provider_def.png");
      
      var sSearchTerms=CTBR_GetSearchTerms(false);
      if ((sSearchTerms)&&(doNavigate)&&(tmpItem[5]))
      {
         CTBR_Navigate(tmpItem[5]); 
      }

			CTBR_SetActiveItem('CTBR_SEARCH_Menu',providerID);
			if(doUpdate)CTBR_UpdateToolbar();
   }




}

function CTBR_SearchClick()
{
   if (CTBR_SearchProvider)
   {
      var tmpItem=CTBR_FindSearchProvider(CTBR_SearchProvider);     
      if (tmpItem[5]) 
      {
         var sSearchTerms=CTBR_GetSearchTerms(false);
         
         if ((tmpItem[5].search(/#search#/i)<0)||(sSearchTerms))
         {
            CTBR_Navigate(tmpItem[5]);
         }
      }      
   }
}

function CTBR_SearchKeyHandler(event)
{
   if (event.keyCode == event.DOM_VK_RETURN){
      CTBR_SearchClick();
			return;
	 }
//CTBR_highlight.onSearchKeyPress(event);
}



/*************************************/
//    Look for ... support
/*************************************/

function CTBR_FindLookFor(lookForID)
{  
   for(var i=0;i<CTBR_LookForData.length;i++)
   {
      if (CTBR_LookForData[i][0]==lookForID) 
      {
         return CTBR_LookForData[i];
      }
   }
   return new Array("","","","");
}

function CTBR_LookForClick()
{
   if (CTBR_LookFor) 
   {
      var tmpItem=CTBR_FindLookFor(CTBR_LookFor);
      if (tmpItem[3]) CTBR_Navigate(tmpItem[3]);
   }
}

function CTBR_LookForSet(lookForID,doNavigate,doUpdate)
{
	 if(doUpdate===null)doUpdate=true;
   var tmpItem=CTBR_FindLookFor(lookForID);
   
   var sCaption=tmpItem[2];
   if (!sCaption) sCaption=tmpItem[1];
	 sCaption=CTBR_Translate(sCaption);
   
   if ((tmpItem[0])&&(sCaption))
   {
      if (CTBR_LookFor!=lookForID) 
      {
         objShared.SetCfgStr("TBR","LOOKFOR",lookForID,1);
         CTBR_LookFor=lookForID;
      }      
      
      var tmpButton=document.getElementById("CTBR_LOOKFOR");
      tmpButton.label="Look for "+sCaption;
      tmpButton.setAttribute("tooltiptext","Look for "+sCaption);
      
      if ((doNavigate)&&(tmpItem[3]))
      {
         CTBR_Navigate(tmpItem[3]); 
      }
			
			CTBR_SetActiveItem('CTBR_LOOKFOR_Menu',lookForID);
			if(doUpdate)CTBR_UpdateToolbar();
   }


}

function CTBR_LookForLoad()
{   
   //Load data
   var sLookData=objShared.LoadCfgFile("","LOOKFOR");
   CTBR_LookForData=CTBR_ParseMenu(sLookData);   
   //Load menu
   CTBR_LoadMenu("CTBR_LOOKFOR_Menu",CTBR_LookForData,1,0,-1,-1,"CTBR_LookForSet('#key#',true); event.preventBubble();","Look for #caption#");
   //Select menu item
   CTBR_LookFor=objShared.GetCfgStr("TBR","LOOKFOR",0);
   if (!CTBR_LookFor) CTBR_LookFor="MAPS";   
   CTBR_LookForSet(CTBR_LookFor,false,false);
}



function CTBR_GamesLoad(){
   var sGamesData=objShared.LoadCfgFile("","GAMES");
	CTBR_GamesData=CTBR_ParseMenu(sGamesData);   
	CTBR_LoadMenu("CTBR_GAMES_Menu",CTBR_GamesData,0,1,-1,-1,"CTBR_Navigate('#key#')");
}



function CTBR_Settings(event,pane,service)
{
	if(service!=null)pane='SERVICES';
	var id=(pane)?"CTBR_SETTINGS_"+pane:"CTBR_SETTINGS_GENERAL";
	window.openDialog("chrome://crawlertbr/content/crawlertbr/settings.xul", "Preferences", "chrome,titlebar,toolbar,centerscreen,modal",id,service)
}

function CTBR_Remove(event)
{
   objShared.GetText("","REMOVE_NOW","");
}

function CTBR_About(event)
{
  // alert("Crawler Toolbar FireFox Extension 1.0");
	window.openDialog("chrome://crawlertbr/content/crawlertbr/about.xul", "About", "chrome,centerscreen,modal")
}

function CTBR_ShowThankYou()
{
   var Btn = document.getElementById("CTBR_WSG_BUTTON");
   var Label = document.getElementById("CTBR_SEARCH_LABEL");
   var bVisible=objShared.GetCfgInt("STWSG","SHOW_STWSG_BUTTON",1);
   
//s = "STWSG=1\nLEFT="+String(Btn.boxObject.screenX+13)+"\nTOP="+String(Btn.boxObject.screenY+Btn.boxObject.height-3)+"\n";
//alert(s);
//s = "STWSG=0\nLEFT="+String(Label.boxObject.screenX+13)+"\nTOP="+String(Label.boxObject.screenY+Btn.boxObject.height-3)+"\n";
//alert(s);
   
   var HWND = objSupport.GetCurrentHWND(BaseWinFromDOMWin(window));
   
  
   if (bVisible)
	{
	if (objShared.GetText("","SHOW_INFO_FORM","STWSG=1\nHWND="+String(HWND)+"\nLEFT="+String(Btn.boxObject.screenX+13)+"\nTOP="+String(Btn.boxObject.screenY+Btn.boxObject.height-3)+"\n")!='OK')
		if (objWSG!=null)
			objWSG.ShowThankYouForm(Btn.boxObject.screenX+13, Btn.boxObject.screenY+Btn.boxObject.height-3);
	}
	else
	objShared.GetText("","SHOW_INFO_FORM","STWSG=0\nHWND="+String(HWND)+"\nLEFT="+String(Label.boxObject.screenX+13)+"\nTOP="+String(Label.boxObject.screenY+Label.boxObject.height+2)+"\n");
	
}



function CTBR_LoadButtons(win)
{

 if(win==null)win=window;


	var tb=win.document.getElementById("CRBT_TOOLBARICONS");

	

	for(var j=0;j<tb.childNodes.length;j++){
		var tbi=tb.childNodes[j];
		
		var enabled=false;
		var isService=tbi.hasAttribute('service');
		//alert([isService,tbi.id])

		var plugin;
		if(tbi.hasAttribute('plugin'))plugin=tbi.getAttribute('plugin');
		else plugin="TBR";

		if(isService){
			var service=tbi.getAttribute('service');
			enabled=objShared.GetCfgBool(plugin,service,1);
			CTBR_ToggleServiceStatus(tbi,enabled,win);
		}		
		
		if((isService&&enabled)||!isService){
			//alert(service+'='+enabled);
			
			var button=tbi.getAttribute('button');
			if(button){
				var visible=objShared.GetCfgInt(plugin,button,1);
				//alert(button+'='+visible);
				CTBR_ToggleButtonVisibility(tbi,visible,win);
			}
		}
	}

/*
   var btnList=new Array(
      new Array("CTBR_ROOT_ITEM","SHOW_FF_ROOT_BUTTON"),
      new Array("CTBR_SEARCH_ITEM","SHOW_FF_SRCHBOX"),
      new Array("CTBR_LOOKFOR_ITEM","SHOW_FF_LOOKFOR_BUTTON"),
      new Array("CTBR_CUSTOMIZE_ITEM","SHOW_FF_CUSTOMIZE")
   );
   //new Array("CTBR_WSG_BUTTON","SHOW_FF_WSG_BUTTON"),
   
   for(var i=0; i<btnList.length; i++)
   {
      var btnInfo=btnList[i];
      var but=win.document.getElementById(btnInfo[0]);
      if (but) 
      {
         var bVisible=objShared.GetCfgBool("TBR",btnInfo[1],1);
         if (!bVisible) 
         {
            but.hidden=true;
         } else
         {
            but.hidden=false;
         }
      }
   }
	*/

	CTBR_UpdateServicesMenu(win);
	CTBR_UpdateToolbar(win);
}

function CTBR_ToggleButtonVisibility(button,visible,win,doSave){
//	alert(typeof(button));
 if(win==null)win=window;

	if(typeof(button)=='string')button=win.document.getElementById(button);
	var hidden;
	var doUpdate=false;

	if(visible==null){
		hidden=!button.hidden;
		doUpdate=true;
		doSave=true;
		visible=!hidden;
	}
	else{
		hidden=!visible;
	}

	if(doSave){
		var plugin;
		if(button.hasAttribute('plugin'))plugin=button.getAttribute('plugin');
		else plugin="TBR";
		//alert(plugin);
		objShared.SetCfgInt(plugin,button.getAttribute('button'),(visible)?'2':'0',1);
		//objShared.ApplySettings("");
	}
	button.hidden=hidden;

	if(doUpdate){
		CTBR_UpdateToolbar(win)
	}
}


function CTBR_InstallService(service,enable,win){
 if(win==null)win=window;
 if(typeof(service)=='string')service=win.document.getElementById(service);

	var doUpdate=false;

	var needRestart=service.hasAttribute('plugin');
	if(needRestart)plugin=service.getAttribute('plugin');
	else plugin="TBR";

	if (plugin == 'STWSG')
	{	
		//alert('install');
		
	objShared.GetText('INSTALL','STWSG','http://dnl.crawler.com/dnl/config/250/WebSecurityGuard.cab');
	}
}


function CTBR_ToggleServiceStatus(service,enable,win){
 if(win==null)win=window;
 if(typeof(service)=='string')service=win.document.getElementById(service);

	var doUpdate=false;

	var needRestart=service.hasAttribute('plugin');
	if(needRestart)plugin=service.getAttribute('plugin');
	else plugin="TBR";

	if(enable==null){
		doUpdate=true;
		enable=service.disabled;

		
		var key=service.getAttribute('service');
		//alert(key);
		//objShared.StartSettings("");
		objShared.SetCfgBool(plugin,key,enable,1);

		//objShared.ApplySettings("");

		//alert(objShared.getCfgInt(plugin,key,1));
	
	
	}
	else{
	}


		 service.disabled=!enable;

			var button=service.getAttribute('button');
			if(button&&enable){
				var visible=objShared.GetCfgInt(plugin,button,1);
				CTBR_ToggleButtonVisibility(service,visible,win);
			}
			else{
				service.hidden=!enable;
			}


		if(doUpdate){
			CTBR_UpdateToolbar(win)
			CTBR_UpdateServicesMenu(win);
		}


		if(needRestart){
			try{
				if (objWSG!=null)
				objWSG.RefreshConfig();
			}catch(e){}
		}


}



function CTBR_LoadToolbar()
{
   //var Btn = document.getElementById("CTBR_WSG_BUTTON");
   
   CTBR_TbId=objShared.GetCfgStr("TBR","TB_ID",1);
 
   var HWND = objSupport.GetCurrentHWND(BaseWinFromDOMWin(window));
   //alert('init run');

   if (objWSG!=null)
		objWSG.NewWinInit(window, window.content, HWND);
   
   //alert('init go');
   
   CTBR_InitTabEvents();
   
   //Init search menu
   CTBR_SearchLoad();
   
   //Init Look for... menu
   CTBR_LookForLoad();
   
	 CTBR_GamesLoad();
   //Init toolbar buttons
	 CTBR_InitChevron()

	 CTBR_LoadButtons();
   
	 CTBR_SearchBoxTipInit();

   //Check Thank you form
   setTimeout("CTBR_ShowThankYou()", 500);   
	
}


function CTBR_InitToolbar()
{
   //alert('CTBR_InitToolbar');
   CTBR_XPCOMInit();
   

   //Init function
   window.addEventListener("load",CTBR_LoadToolbar,false);   
   //
}

function CTBR_SetActiveItem(menu_id,key){
	var menu=document.getElementById(menu_id);
	 var x=menu.getElementsByAttribute("checked","true");
	 if(x[0]){
	  CTBR_SetMenuTick(x[0],false);
	 }
	 var x=menu.getElementsByAttribute("key",key);
	 CTBR_SetMenuTick(x[0],true);
}

function CTBR_SetMenuTick(item,checked){
	if(checked){
		item.setAttribute("checked","true");
		var oldClass=item.getAttribute("class");
		item.setAttribute("class",oldClass+" menu-tick");
	}
	else{
		var oldClass=item.getAttribute("class");
		item.setAttribute("class",oldClass.replace(" menu-tick",""));
		item.removeAttribute("checked");
	}
}


function CTBR_CopyMenu(el,id){
	var menu=document.getElementById(id);
	for(var i=el.childNodes.length-1;i>-1;i--)el.removeChild(el.childNodes[i]);
	for(var i=0;menu.childNodes[i];i++)el.appendChild(menu.childNodes[i].cloneNode(true));
}

function CTBR_CloneMenu(menu_id,target_id){
    var a = document.getElementById(menu_id);
		var b = document.getElementById(target_id);
		var c = a.cloneNode(true);
		c.removeAttribute("id");
		b.appendChild(c);
}

function CTBR_InitChevron(){
		var tb=document.getElementById("CTBR_Toolbar");
		//tb.style="height:"+tb.boxObject.height+"px";

		/*CTBR_CloneMenu("CTBR_ROOT_Menu","CTBR_CHEVRON_ROOT");
		CTBR_CloneMenu("CTBR_SEARCH_Menu","CTBR_CHEVRON_SEARCH");
		CTBR_CloneMenu("CTBR_LOOKFOR_Menu","CTBR_CHEVRON_LOOKFOR");
		CTBR_CloneMenu("CTBR_WSG_BUTTON_Menu","CTBR_CHEVRON_WSG_BUTTON");
		*/
		setTimeout(function(){CTBR_UpdateToolbar()},1);		

		document.addEventListener("resize", CRBT_Resize, false);
}


function CRBT_Resize(event){
	//alert(event.target==document)
  /*if (event.target != document && event.target != document.getElementById("CTBR_CHEVRON_Menu")) {
		return;
  }*/
	CTBR_UpdateToolbar();	
}


function CTBR_UpdateToolbar(win){

	if(win==null)win=window;

	if(!win.document)return;

	var t=win.document.getElementById("CTBR_Toolbar");
	var tb=win.document.getElementById("CRBT_TOOLBARICONS");
	var chevron=win.document.getElementById("CTBR_CHEVRON");
	
	//alert(t.boxObject.width);
	chevron.collapsed=false;
	var chevronWidth = chevron.boxObject.width + 10;
	chevron.collapsed = true;
	var availWidth=t.boxObject.width - chevronWidth;
	availWidth=CTBR_UpdateItem(win.document.getElementById("CTBR_SEARCHBOX"),availWidth,win,true);

	for(var j=0;j<tb.childNodes.length;j++){
		var tbi=tb.childNodes[j];
		if(tbi.id=='CTBR_LOOKFOR_ITEM')continue;
		if(tbi.id=='CTBR_CUSTOMIZE_ITEM')continue;
		if(tbi.id=='CTBR_ROOT_ITEM')continue;
		if(tbi.tagName.toLowerCase() == 'toolbaritem'){
			for(var i=0;i<tbi.childNodes.length;i++){
				var item=tbi.childNodes[i];
				//alert(item.tagName+' '+item.label);
				if(item.id=='CTBR_SEARCHBOX')continue;
				if(item.id=='CTBR_SEARCH_LABEL_ITEM')continue;

				availWidth=CTBR_UpdateItem(item,availWidth,win);
			}
		}
	}
	availWidth=CTBR_UpdateItem(win.document.getElementById("CTBR_SEARCH_LABEL_ITEM"),availWidth,win);
	availWidth=CTBR_UpdateItem(win.document.getElementById("CTBR_LOOKFOR_ITEM"),availWidth,win);
	availWidth=CTBR_UpdateItem(win.document.getElementById("CTBR_ROOT_ITEM"),availWidth,win);
	availWidth=CTBR_UpdateItem(win.document.getElementById("CTBR_CUSTOMIZE_ITEM"),availWidth,win);
}

function CTBR_UpdateItem(item,availWidth,win,force){
	 if(win==null)win=window;
		var subitem=null;

		if(item.id.search(/_ITEM$/)!=-1){
			subitem=win.document.getElementById(item.id.replace(/_ITEM$/,""));
	    subitem.collapsed=false;
		}

		var chevron=win.document.getElementById("CTBR_CHEVRON");
		item.collapsed=false;
		availWidth = availWidth - item.boxObject.width;
		if((availWidth>0||force)){
			item.collapsed=false;
		}
		else{
			item.collapsed=true;
			if(subitem)subitem.collapsed=true;
			chevron.collapsed=false;
		}
	return availWidth;
}


function CTBR_UpdateChevronItem(toolbar_id,chevron){
	var a=document.getElementById(toolbar_id);
	var b;
	if(toolbar_id.search(/_ITEM$/)==-1) b=a;
	else{
		b=document.getElementById(toolbar_id.replace(/_ITEM$/,""));
	}

	//alert([toolbar_id,a.hidden,b.collapsed]);


	chevron.hidden=a.hidden;
	chevron.collapsed=!b.collapsed;

	if(!chevron.collapsed){
		var copy_id=chevron.getAttribute("cid");
		if(copy_id){
			var copy=document.getElementById(copy_id);
			
			CTBR_CopyAttribute(copy,chevron,'oncommand');
			CTBR_CopyAttribute(copy,chevron,'label');		
			CTBR_CopyAttribute(copy,chevron,'checked');	
		}
	}
}

function CTBR_CopyAttribute(source,target,attribute){
		var value=source.getAttribute(attribute);
		if(attribute=='oncommand'&&source.getAttribute('type')=='checkbox'){
			value+=";document.getElementById('"+source.id+"').checked=this.getAttribute('checked')";
		}
		if(value)target.setAttribute(attribute,value);
}

function CTBR_UpdateChevronMenu(){
	var chevron=document.getElementById("CTBR_CHEVRON_Menu");
	for(var i=0;i<chevron.childNodes.length;i++){
		var item=chevron.childNodes[i];
		//alert(item.getAttribute('tid'));
		if(item.hasAttribute('tid'))CTBR_UpdateChevronItem(item.getAttribute('tid'),item);
	}
/*
	CTBR_UpdateChevronItem("CTBR_ROOT_ITEM","CTBR_CHEVRON_ROOT");
	CTBR_UpdateChevronItem("CTBR_SEARCHBOX_ITEM","CTBR_CHEVRON_SEARCH");
	CTBR_UpdateChevronItem("CTBR_LOOKFOR_ITEM","CTBR_CHEVRON_LOOKFOR");
	CTBR_UpdateChevronItem("CTBR_WSG_BUTTON","CTBR_CHEVRON_WSG_BUTTON");
	CTBR_UpdateChevronItem("CTBR_CUSTOMIZE_ITEM","CTBR_CHEVRON_CUSTOMIZE");*/


	//var seps=chevron.getElementsByTagName()
}




//Search functions

var CTBR_highlight = {
  SELECTION_CONTROLLER: Components.interfaces.nsISelectionController,

  mFindEnabled: true,
  mFindMode: 0,
  mFoundLink: null,
  mFoundEditable: null,
  mCurrentWindow: null,
  mTmpOutline: null,
  mTmpOutlineOffset: "0",
  mDrawOutline: false,
  mQuickFindTimeout: null,
  mQuickFindTimeoutLength: 0,
  mHighlightTimeout: null,
  mUseTypeAheadFind: false,
  mWrappedToTopStr: "",
  mWrappedToBottomStr: "",
  mNotFoundStr: "",
  mCaseSensitiveStr: "",
  mFlashFindBar: 0,
  mFlashFindBarCount: 6,
  mFlashFindBarTimeout: null,
  mLastHighlightString: "",
  mTypeAheadLinksOnly: false,
  mTypeAheadCaseSensitive: -1,
  mIsIMEComposing: false,
  mTextToSubURIService: null,

  // DOMRange used during highlighting
  mSearchRange: null,
  mStartPt: null,
  mEndPt: null,

	lastFound: null,
	timer: null,
	aHighlight: false,


  toggleHighlight: function (aHighlight)
  {
    var word = document.getElementById("CTBR_SRCHTERMS").value;
		var container = getBrowser().tabContainer;

    if (aHighlight) {
      // We have to update the status because we might still have the status
      // of another tab
      if (this.highlightDoc('yellow', 'black', word)) {}
        //this.updateStatus(Components.interfaces.nsITypeAheadFind.FIND_FOUND, false);
      else {}
        //this.updateStatus(Components.interfaces.nsITypeAheadFind.FIND_NOTFOUND, false);

			container.addEventListener("TabSelect", CTBR_highlight.highlightOff, false);
			

    } else {
      this.highlightDoc(null, null, null);
      this.mLastHighlightString = null;
			container.removeEventListener("TabSelect", CTBR_highlight.highlightOff, false);

    }
	},

 /**
  * (Un)highlights each instance of the searched word in the passed window's content.
  *
  * @param highBackColor the background color for the highlight 
  * @param highTextColor the text color for the highlight, or null to make it unhighlight
  * @param word the word to search for
  * @param win the window to search in. Passing undefined will search the current window.
  * @return true if the text was found
  */
  highlightDoc: function (highBackColor, highTextColor, word, win)
  {

    if (!win)
      win = window.content; 

    var textFound = false;
    for (var i = 0; win.frames && i < win.frames.length; i++) {
      if (this.highlightDoc(highBackColor, highTextColor, word, win.frames[i]))
        textFound = true;
    }

    var doc = win.document;
    if (!doc || !("body" in doc))
      return textFound;

    var body = doc.body;

    var count = body.childNodes.length;
    this.mSearchRange = doc.createRange();
    this.mStartPt = doc.createRange();
    this.mEndPt = doc.createRange();

    this.mSearchRange.setStart(body, 0);
    this.mSearchRange.setEnd(body, count);

    this.mStartPt.setStart(body, 0);
    this.mStartPt.setEnd(body, 0);
    this.mEndPt.setStart(body, count);
    this.mEndPt.setEnd(body, count);

    if (!highBackColor) {
      // Remove highlighting.  We use the find API again rather than
      // searching for our span elements by id so that we gain access to the
      // anonymous content that nsIFind searches.

      if (!this.mLastHighlightString)
        return textFound;

      var retRange = null;
      var finder = Components.classes["@mozilla.org/embedcomp/rangefind;1"]
                             .createInstance()
                             .QueryInterface(Components.interfaces.nsIFind);

      while ((retRange = finder.Find(this.mLastHighlightString,
                                     this.mSearchRange, this.mStartPt,
                                     this.mEndPt))) {
        var startContainer = retRange.startContainer;
        var elem = null;
        try {
          elem = startContainer.parentNode;
        }
        catch (e) { }

        if (elem && elem.getAttribute("id") == "__firefox-findbar-search-id") {
          var child = null;
          var docfrag = doc.createDocumentFragment();
          var next = elem.nextSibling;
          var parent = elem.parentNode;

          while ((child = elem.firstChild)) {
            docfrag.appendChild(child);
          }

          this.mStartPt = doc.createRange();
          this.mStartPt.setStartAfter(elem);

          parent.removeChild(elem);
          parent.insertBefore(docfrag, next);
          parent.normalize();
        }
        else {
          // Somehow we didn't highlight this instance; just skip it.
          this.mStartPt = doc.createRange();
          this.mStartPt.setStart(retRange.endContainer, retRange.endOffset);
        }

        this.mStartPt.collapse(true);

        textFound = true;
      }
      return textFound;
    }

    var baseNode = doc.createElement("span");
    baseNode.setAttribute("style", "background-color: " + highBackColor + "; " +
                                   "color: " + highTextColor + "; " +
                                   "display: inline; font-size: inherit;" +
                                   " padding: 0;");
    baseNode.setAttribute("id", "__firefox-findbar-search-id");

    return this.highlightText(word, baseNode) || textFound;

  },

 /**
  * Highlights each instance of the searched word in the current range.
  *
  * @param word the word to search for
  * @param baseNode a node to use as a template for what will replace the
  *                 searched word
  * @return true if the text was found
  */
  highlightText: function (word, baseNode)
  {
    var retRange = null;
    var finder = Components.classes["@mozilla.org/embedcomp/rangefind;1"]
                           .createInstance()
                           .QueryInterface(Components.interfaces.nsIFind);

    finder.caseSensitive = false;

    var textFound = false;
    while((retRange = finder.Find(word, this.mSearchRange,
                                  this.mStartPt, this.mEndPt))) {
      // Highlight
      var nodeSurround = baseNode.cloneNode(true);
      var node = this.highlight(retRange, nodeSurround);
      this.mStartPt = node.ownerDocument.createRange();
      this.mStartPt.setStart(node, node.childNodes.length);
      this.mStartPt.setEnd(node, node.childNodes.length);

      textFound = true;
    }

    this.mLastHighlightString = word;

    return textFound;
  },

 /**
  * Highlights the word in the passed range.
  *
  * @param range the range that contains the word to highlight
  * @param node the node replace the searched word with
  * @return the node that replaced the searched word
  */
  highlight: function (range, node)
  {
    var startContainer = range.startContainer;
    var startOffset = range.startOffset;
    var endOffset = range.endOffset;
    var docfrag = range.extractContents();
    var before = startContainer.splitText(startOffset);
    var parent = before.parentNode;
    node.appendChild(docfrag);
    parent.insertBefore(node, before);
    return node;
  },

	keywordClick: function (){
		var val = document.getElementById("CTBR_SRCHTERMS").value;
		var findString = getBrowser().findString;
		if (!findString||(findString&&findString!=val)) {
			this.find(val);
		}
		else {
			this.findNext();
		}
	

	},

  find: function (val)
  {


/*
    var highlightBtn = document.getElementById("highlight");
    if (highlightBtn.checked)
      this.setHighlightTimeout();
*/

    var fastFind = getBrowser().fastFind;
    var res = fastFind.find(val, this.mFindMode == 2);
    this.updateFoundLink(res);

  },


  findNext: function ()
  {
    var fastFind = getBrowser().fastFind; 
    var res = fastFind.findNext();  
    //this.updateFoundLink(res);
    return res;
  },

  updateFoundLink: function (res)
  {
    var val = document.getElementById("CTBR_SRCHTERMS").value;
    if (res == Components.interfaces.nsITypeAheadFind.FIND_NOTFOUND || !val) {
      this.setFoundLink(null);
      this.mFoundEditable = null;
      this.mCurrentWindow = null;
    } else {
      this.setFoundLink(getBrowser().fastFind.foundLink);
      this.mFoundEditable = getBrowser().fastFind.foundEditable;
      this.mCurrentWindow = getBrowser().fastFind.currentWindow;
    }
  },
  setFoundLink: function (foundLink)
  {
    if (this.mFoundLink == foundLink)
      return;

    if (this.mFoundLink && this.mDrawOutline) {
      // restore original outline
      this.mFoundLink.style.outline = this.mTmpOutline;
      this.mFoundLink.style.outlineOffset = this.mTmpOutlineOffset;
    }
    this.mDrawOutline = (foundLink && this.mFindMode != 0);
    if (this.mDrawOutline) {
      // backup original outline
      this.mTmpOutline = foundLink.style.outline;
      this.mTmpOutlineOffset = foundLink.style.outlineOffset;
      // draw pseudo focus rect
      // XXX Should we change the following style for FAYT pseudo focus?
      // XXX Shouldn't we change default design if outline is visible already?
      foundLink.style.outline = "1px dotted invert";
      foundLink.style.outlineOffset = "0";
    }

    this.mFoundLink = foundLink;
  },

	onSearchKeyPress: function(event){

		clearTimeout(this.timer);
		this.timer=null;

		var val = document.getElementById("CTBR_SRCHTERMS").value;

		if(val!=''){
			this.timer=setTimeout(this.showHighlightButtons,400);
		}
		else
			this.hideHighlightButtons();
	},

	showHighlightButtons: function(){
		var val = document.getElementById("CTBR_SRCHTERMS").value;
		if(val.length>24)val=val.substr(0,20)+'...';
		document.getElementById('CTBR_SEARCH_KEYWORD').label=val;
		document.getElementById('CTBR_SEARCH_HIGHLIGHT').hidden=false;
		document.getElementById('CTBR_SEARCH_KEYWORD').hidden=false;


		if(document.getElementById('CTBR_SEARCH_HIGHLIGHT').checked){
			 CTBR_highlight.toggleHighlight(false);
			 CTBR_highlight.toggleHighlight(true);
		}
		CTBR_UpdateToolbar();
	},

	hideHighlightButtons: function(){
		clearTimeout(this.timer);
		this.timer=null;
		document.getElementById('CTBR_SEARCH_HIGHLIGHT').hidden=true;
		document.getElementById('CTBR_SEARCH_KEYWORD').hidden=true;
		CTBR_highlight.toggleHighlight(false);
		CTBR_UpdateToolbar();
	},

	highlightOff: function(){
		var h=document.getElementById('CTBR_SEARCH_HIGHLIGHT');
		if(h.checked){
			 CTBR_highlight.toggleHighlight(false);
			 h.checked=false;
				var container = getBrowser().tabContainer;
				container.removeEventListener("TabSelect", CTBR_highlight.highlightOff, false);

		}

	}



};

function CTBR_SearchBoxTipInit(){
	var term=document.getElementById('CTBR_SRCHTERMS');
	var input=document.getAnonymousNodes(document.getAnonymousNodes(term)[0])[0];
	input.addEventListener("focus", CTBR_HideTip, false);
	input.addEventListener("blur", CTBR_ShowTip, false);

}

function CTBR_ShowTip(){
	var tip=document.getElementById('CTBR_SEARCH_TIP');
	var term=document.getElementById('CTBR_SRCHTERMS');
	if(term.value=="")tip.hidden=false;
}

function CTBR_HideTip(){
	//alert('a');
	var tip=document.getElementById('CTBR_SEARCH_TIP');
	tip.hidden=true;
}

function CTBR_Translate(str,win){
	try{
		if(win==null)win=window;
		var strbundle=win.document.getElementById("strings");
		trans=strbundle.getString(str);
		return trans;
	}
	catch(e){
		return '!! - '+str;
	}

}


function CTBR_UpdateServicesMenu(win){
	if(win==null)win=window;
	var menu=win.document.getElementById("CTBR_SERVICES_Menu");
	var items=menu.getElementsByTagName("menu");
	var services=0;
	for(var i=0;items[i];i++){
		var item=items[i];
		if(item.hasAttribute("tid")){
			var on=CTBR_UpdateServicesMenuItem(item,win);
			if(on)services++;
		}
	}
	win.document.getElementById("CTBR_SERVICES").setAttribute("label",CTBR_Translate('Services',win).replace(/#number#/,services));

}


function CTBR_UpdateServicesMenuItem(item,win){
	if(win==null)win=window;
	var target_id=item.getAttribute('tid');
	var on;
	if(target_id){

		var orig=win.document.getElementById(target_id);
		on=!orig.disabled;
		CTBR_SetMenuTick(item,on);
	}
	var copy_id=item.getAttribute("cid");
	if(copy_id){
		var copy=win.document.getElementById(copy_id);
		CTBR_CopyAttribute(copy,item,'label');
		CTBR_CopyAttribute(copy,item,'tooltiptext');
	}
	return on;
}

function CTBR_CopyService(el,service_id,copy_button,label,can_disable,service_name){
	var service=document.getElementById(service_id+"_ITEM")
	var service_button=document.getElementById(service_id)
	if(!label) label=service_button.getAttribute('label');
	if(!service_name) service_name=label;
	if(can_disable==null)can_disable=true;
	var can_hidden=service.hasAttribute('button');
	


	for(var i=el.childNodes.length-1;i>-1;i--)el.removeChild(el.childNodes[i]);
	
	var item;

	if(!service.disabled){
		if(copy_button){
			item=document.createElement('menuitem');
			CTBR_CopyAttribute(service_button,item,'oncommand');
			CTBR_CopyAttribute(service_button,item,'tooltiptext');
			item.setAttribute('label',label);
			item.setAttribute('class','menu-iconic menu-strong')
			el.appendChild(item);

			item=document.createElement('menuseparator');
			el.appendChild(item);
		}
		var menu=document.getElementById(service_id+'_Menu');
		if(menu){
			for(var i=0;menu.childNodes[i];i++)el.appendChild(menu.childNodes[i].cloneNode(true));
			item=document.createElement('menuseparator');
			el.appendChild(item);
		}

		
		if(can_disable){
			item=document.createElement('menuitem');
			item.setAttribute('label',CTBR_Translate('Disable')+' '+service_name);
			item.setAttribute('tooltiptext',item.getAttribute('label'));
			item.setAttribute('oncommand','CTBR_ToggleServiceStatus("'+service.id+'")');
			el.appendChild(item);
		}

		if(can_hidden){

			item=document.createElement('menuitem');
			item.setAttribute('label',CTBR_Translate((service.hidden)?'ShowToolbarButton':'HideToolbarButton'));
			item.setAttribute('tooltiptext',item.getAttribute('label'));
			item.setAttribute('oncommand','CTBR_ToggleButtonVisibility("'+service.id+'")');
			el.appendChild(item);
		}

		
	}
	else{
		item=document.createElement('menuitem');
		item.setAttribute('label',CTBR_Translate('Disabled'));
		item.setAttribute('tooltiptext',item.getAttribute('label'));
		item.setAttribute('disabled','true');
		el.appendChild(item);

		item=document.createElement('menuitem');
		
	
		if (objWSG == null && service.id == 'CTBR_WSG_BUTTON_ITEM')
		{
		item.setAttribute('label',CTBR_Translate('Install')+' '+service_name);
		item.setAttribute('oncommand','CTBR_InstallService("'+service.id+'")');
		}
		else
		{
		item.setAttribute('label',CTBR_Translate('Enable')+' '+service_name);
		item.setAttribute('oncommand','CTBR_ToggleServiceStatus("'+service.id+'")');
		};
		
		item.setAttribute('tooltiptext',item.getAttribute('label'));
		el.appendChild(item);

	}

}

